/* (C) 2009-2011 Yana */

#if !defined(Y_DEVICE_H)
#define Y_DEVICE_H

#if !defined(Y_PREPROCESS_ONLY)

#include "y_base.h"
#include "device.h"

#if !defined(__GNUC__)
#define __inline__
#endif

__inline__ static y_uint8_t y_device_cons_getchar(void) {
	return *(volatile y_uint8_t *)DEVICE_CONS_PUTGETCHAR;
}

__inline__ static void y_device_cons_halt(void) {
	*(volatile y_uint8_t *)DEVICE_CONS_HALT = 0;
}

__inline__ static void y_device_cons_putchar(y_uint8_t c) {
	*(volatile y_uint8_t *)DEVICE_CONS_PUTGETCHAR = c;
}

__inline__ static void y_device_cons_initialize(void) {
}

__inline__ static void y_device_cons_put_hexadecimal(y_uint32_t hexadecimal) {
	y_uint32_t i;
	for (i = 0; i < 8; ++i) {
		y_device_cons_putchar("0123456789abcdef"[hexadecimal >> (28 - i * 4) & 0xf]);
	}
}

__inline__ static void y_device_cons_put_string(const char *string) {
	while (*string != 0) {
		y_device_cons_putchar(*string);
		++string;
	}
}

#endif

#endif
